  function [c10, c20]=M72gradient(x,y,C1,C2)
% Approximation of values (x(i),y(i)), pro i=1,2,...,N by a
%   function f(x)=f(x)=1/(exp(c1*x+c2)+1) using gradient method
% Definition of given values and error surface plot
  if exist('x')==0
    x=[-3 -1 1 2]'; y=1./(exp(-0.6*x+0.4)+1);
    C1=-2:0.2:2; C2=-3:0.2:3;
  end
  for i=1:length(C1);
    for j=1:length(C2)
      S(i,j)=sum((y-fa([C1(i),C2(j)],x)).^2);
    end;
  end
% Solution by gradient method
  c10(1)=1; c20(1)=-3; alpha=0.8; M=250; plot(c20,c10,'o');
  for k=1:M
    dc1=sum((y-fa([c10(k),c20(k)],x)).*...
           exp(c10(k)*x+c20(k))./(exp(c10(k)*x+c20(k))+1).^2 .*x);
    dc2=sum((y-fa([c10(k),c20(k)],x)).*...
           (exp(c10(k)*x+c20(k)))./(exp(c10(k)*x+c20(k))+1).^2);
    if(abs(dc1)+abs(dc2)<0.000001), break; end;
      c10(k+1)=c10(k)-alpha*dc1;
      c20(k+1)=c20(k)-alpha*dc2;
    end; 
% Plot of given and approximation values
  subplot(1,2,1); meshc(C2,C1,S); axis tight
    xlabel('C2'); ylabel('C1'); title('ERROR SURFACE')'
  subplot(2,2,4); contour(C2,C1,S,50);
    hold on; plot(c20,c10,'o'); hold off
    xlabel('C2'); ylabel('C1'); title('CONTOUR PLOT')'
  subplot(2,2,2);
    stem(x,y); axis tight; hold on;
      xx=min(x):0.1:max(x);
      plot(xx,fa([c10(end), c20(end)],xx),'r'); hold off; grid on;
    title('APPROXIMATION')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  function f=fa(c,x)
  f=1./(exp(c(1)*x+c(2))+1);